#include <stdio.h>

#include "date.h"

struct date_s date_from_string(const char* s)
{
    struct date_s d;
    sscanf(s, "%d/%d/%d", &d.day, &d.month, &d.year);
    return d;
}

void date_to_string(const struct date_s* const date, char sep, char* str)
{
    sprintf(str, "%02d%c%02d%c%d", date->day, sep, date->month, sep, date->year);
}

int date_compare(const struct date_s* const d1, const struct date_s* const d2)
{
    return (d1->year * 365 + d1->month * 31 + d1->day) - (d2->year * 365 + d2->month * 31 + d2->day);
}

int date_get_value(const struct date_s* const date, const enum date_value_e value)
{
    switch (value)
    {
        case YEAR:
            return date->year;
        case MONTH:
            return date->month;
        case DAY:
            return date->day;
        default:
            return -1;
    }
}

int date_is_bissextile(const struct date_s* const date)
{
    const int year = date->year;
    return (year % 4 == 0 && year % 100 != 0) || (year % 400 == 0);
}
