#include <assert.h>
#include <stdio.h>
#include <stdlib.h>

#include "date.h"


int main(int argc, char* argv[])
{
    struct date_s d = date_from_string("01/11/2023");
    struct date_s d_before = date_from_string("31/10/2023");
    struct date_s d_after = date_from_string("02/11/2023");

    char buffer[11];
    date_to_string(&d, '-', buffer);
    printf("%s\n", buffer);

    assert(date_compare(&d, &d) == 0);
    assert(date_compare(&d_before, &d) < 0);
    assert(date_compare(&d, &d_before) > 0);
    assert(date_compare(&d_after, &d) > 0);
    assert(date_compare(&d, &d_after) < 0);

    assert(date_get_value(&d, YEAR) == 2023);
    assert(date_get_value(&d, MONTH) == 11);
    assert(date_get_value(&d, DAY) == 1);
    assert(date_get_value(&d, 42) == -1);

    assert(date_is_bissextile(&d) == 0);

    return EXIT_SUCCESS;
}
