#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

char code(const int c, const int key)
{
    if (islower(c))
    {
        return ((c - 'a' + key) % 26) + 'a';
    }
    else if (isupper(c))
    {
        return ((c - 'A' + key) % 26) + 'A';
    }
    else
    {
        return c;
    }
}

int main(int argc, char* argv[])
{
    if (argc < 2 || argc > 3)
    {
        printf("%s <cle> [<fichier>]\n", argv[0]);
        return EXIT_FAILURE;
    }

    const int key = atoi(argv[1]);
    int from_file = argc == 3;
    FILE* fd;

    if (from_file)
    {
        fd = fopen(argv[2], "r");
        if (fd == NULL)
        {
            perror("Erreur à l'ouverture du fichier");
            return EXIT_FAILURE;
        }
    }
    else
    {
        fd = stdin;
    }

    int c;
    while ((c = fgetc(fd)) != EOF)
    {
        printf("%c", code(c, key));
    }

    if (from_file)
    {
        fclose(fd);
    }

    return EXIT_SUCCESS;
}
